/*
 *		Implantation des tables d'assemblages
 *		< Code machines , Instructions >
 *
 * 	Auteur : FAVARD Laurent
 *	Fichier: TABLEASM.H
 *	Pays   : FRANCE
 *	Date   : 26 Mars 1994
 *	Revision: 1 Avril 1994
 *	Version : 1.0
 *	Release : 1.2
 *	Machine : ATARI Falcon030 TOS 4.2
 *	Processeur cible: MC68705 P3S (Famille 6805)
 */

/*
	Dfinition du type d'une entre d'une table
*/
 
typedef struct {
		 char Inst[6];
		 int  CodeMachine;
	       } Type_CodeMachine;

/*
	Tables des codes machines
*/
			
	       
Type_CodeMachine TableInherant[40]={"ASRA",0x47,"ASRX",0x57,
				    "ASLA",0x48,"ASLX",0x58,
				    "CLRA",0x4F,"CLRX",0x5F,
				    "COMA",0x43,"COMX",0x53,
				    "DECA",0x4A,"DECX",0x5A,
				    "INCA",0x4C,"INCX",0x5C,
				    "LSLA",0x48,"LSLX",0x58,
				    "LSRA",0x44,"LSRX",0x54,
				    "NEGA",0x40,"NEGX",0x50,
				    "ROLA",0x49,"ROLX",0x59,
				    "RORA",0x46,"RORX",0x56,
				    
				    "CLI", 0x9A,"CLC", 0x98,
				    "NOP", 0x9D,"RTI", 0x80,
				    "RSP", 0x9C,"RTS", 0x81,
				    "STOP",0x8E,"SWI", 0x83,
				    "SEI", 0x9B,"SEC", 0x99,
				    "TSTA",0x4D,"TSTX",0x5D,
				    "TAX", 0x97,"TXA", 0x9F,
				    "WAIT",0x8F,"",    0x00};

Type_CodeMachine TableImmediat[13]={"ADD", 0xAB,"ADC", 0xA9,
				    "AND", 0xA4,"BIT", 0xA5,
				    "CPX", 0xA3,"CMP", 0xA1,
				    "EOR", 0xA8,"LDA", 0xA6,
				    "LDX", 0xAE,"ORA", 0xAA,
				    "SUB", 0xA0,"SBC", 0xA2,
				    "",0x00};

Type_CodeMachine TableRelatif[20]= {"BRA", 0x20,"BRN", 0x21,
				    "BHI", 0x22,"BLS", 0x23,
				    "BCC", 0x24,"BHS", 0x24,
				    "BCS", 0x25,"BLO", 0x25,
				    "BNE", 0x26,"BEQ", 0x27,
				    "BHCC",0x28,"BHCS",0x29,
				    "BPL", 0x2A,"BMI", 0x2B,
				    "BMC", 0x2C,"BMS", 0x2D,
				    "BIL", 0x2E,"BIH", 0x2F,
				    "BSR", 0xAD,"",0x00};

Type_CodeMachine TableDirect[30]=  {"ASL",0x38,"ASR",0x37,
				    "ADD",0xBB,
				    "ADC",0xB9,"AND",0xB4,
				    "BIT",0xB5,"CMP",0xB1,
				    "CPX",0xB3,"CLR",0x3F,
				    "COM",0x33,"DEC",0x3A,
				    "EOR",0xB8,"INC",0x3C,
				    "JMP",0xBC,"JSR",0xBD,
				    "LSL",0x38,"LDA",0xB6,
				    "LDX",0xBE,"LSR",0x34,
				    "NEG",0x30,"ORA",0xBA,
				    "ROL",0x39,"ROR",0x36,
				    "STA",0xB7,"STX",0xBF,
				    "SUB",0xB0,"SBC",0xB2,
				    "TST",0x3D,"",0X00};

Type_CodeMachine TableEtendu[17]=  {"ADD",0xCB,"ADC",0xC9,
				    "AND",0xC4,"BIT",0xC5,
				    "CMP",0xC1,"CPX",0xC3,
				    "EOR",0xC8,
				    "JMP",0xCC,"JSR",0xCD,
				    "LDA",0xC6,
				    "LDX",0xCE,"ORA",0xCA,
				    "STA",0xC7,"STX",0xCF,
				    "SUB",0xC0,"SBC",0xC2,
				    
				    "",0X00};				  

Type_CodeMachine Table0Index[30]=  {"INC",0x7C,"DEC",0x7A,
				    "CLR",0x7F,"COM",0x73,
				    "NEG",0x70,"ROL",0x79,
				    "ROR",0x76,"LSL",0x78,
				    "LSR",0x74,"ASR",0x77,
				    "ASL",0x78,"TST",0x7D,
				    "LDA",0xF6,"LDX",0xFE,
				    "STA",0xF7,"STX",0xFF,
				    "ADD",0xFB,"ADC",0xF9,
				    "SUB",0xF0,"SBC",0xF2,
				    "AND",0xF4,"ORA",0xFA,
				    "EOR",0xF8,"CMP",0xF1,
				    "CPX",0xF3,"BIT",0xF5,
				    "JMP",0xFC,"JSR",0xFD,
				    "",0x00};

Type_CodeMachine Table8Index[30]=  {"INC",0x6C,"DEC",0x6A,
				    "CLR",0x6F,"COM",0x63,
				    "NEG",0x60,"ROL",0x69,
				    "ROR",0x66,"LSL",0x68,
				    "LSR",0x64,"ASR",0x67,
				    "ASL",0x68,"TST",0x6D,
				    "LDA",0xE6,"LDX",0xEE,
				    "STA",0xE7,"STX",0xEF,
				    "ADD",0xEB,"ADC",0xE9,
				    "SUB",0xE0,"SBC",0xE2,
				    "AND",0xE4,"ORA",0xEA,
				    "EOR",0xE8,"CMP",0xE1,
				    "CPX",0xE3,"BIT",0xE5,
				    "JMP",0xEC,"JSR",0xED,
				    "",0x00};

Type_CodeMachine Table16Index[30]= {"LDA",0xD6,"LDX",0xDE,
				    "STA",0xD7,"STX",0xDF,
				    "ADD",0xDB,"ADC",0xD9,
				    "SUB",0xD0,"SBC",0xD2,
				    "AND",0xD4,"ORA",0xDA,
				    "EOR",0xD8,"CMP",0xD1,
				    "CPX",0xD3,"BIT",0xD5,
				    "JMP",0xDC,"JSR",0xDD,
				    "",0x00};
				    
/*
  Fin de fichier dfinition
*/
