/*
 * ----------------------------------------------------------------------------------------------
 *			Module de generation de code source
 *
 * 	Author  : 	FAVARD Laurent
 *	File    : 	CODEGEN.C
 *	Date    : 	19 December 1998
 *	Release : 	25 January 1999
 *	Version : 	1.0
 *	Country : 	FRANCE
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * ----------------------------------------------------------------------------------------------
 */

#include <tos.h>
#include <stdio.h>
#include <string.h>

#include 	<PcAads.h>
#include 	<JToolBox.h>

/* ---------------------------------------------------------------------------------------------- */

#include	"..\modules\Codegen.h"
#include 	"..\modules\Messages.h"
#include 	"..\modules\Const.h"
#include 	"..\modules\Tools.h"

/* ---------------------------------------------------------------------------------------------- */

/* ---------------------------------------------------------------------------------------------- */
void MkHead( FILE *Fichier, TSource *Definition )
{
fprintf( Fichier, ";\t------------------------------------------------------------------------------\n");
fprintf( Fichier, ";\tTitle:%s\n", Definition->Title);
fprintf( Fichier, ";\n");
fprintf( Fichier, ";\tCopyright (c) %s %s\n", Definition->Author, Definition->Date);
fprintf( Fichier, ";\tCode generated by JagStudio98 for DEVPAC 3, copyright FAVARD laurent 1996-1998\n");
fprintf( Fichier, ";\n");
fprintf( Fichier, ";\tBusiness:%s\n", Definition->Business);
fprintf( Fichier, ";\t------------------------------------------------------------------------------\n");
fprintf( Fichier, "\n");
fprintf( Fichier, "\t\tinclude\t\t\".\\Include\\sysapi.inc\"\n");
fprintf( Fichier, "\t\tinclude\t\t\".\\Include\\jag.inc\"\n");
fprintf( Fichier, "\n");
fprintf( Fichier, "\t\tOUTPUT\t\t%s%s\n", Definition->ExecName, EXT_JAG2);
fprintf( Fichier, "\n");
fprintf( Fichier, "\t\tOPT	D-\t\t\t; No debugging\n");
fprintf( Fichier, "\n");
fprintf( Fichier, "\t\tdc.b\t'JAGR'\t\t\t; Magic to skip Devpac Header\n");
fprintf( Fichier, "\t\tdc.w\t3\t\t\t; JagOS 3 - Receive & Run\n");
fprintf( Fichier, "\t\tdc.l\t$%s\t\t\t; Upload adress\n", Definition->UploadAddress);
fprintf( Fichier, "\t\tdc.l\tC_End-C_Start\t\t; Lenght of Jaguar Code\n");
fprintf( Fichier, "\t\tdc.l\t$%s\t\t\t; Start address code\n", Definition->StartAddress);
fprintf( Fichier, "\n\n");

fprintf( Fichier, "\t\tTEXT\n");
fprintf( Fichier, "\t\tOrg\t\t$%s\n", Definition->StartAddress);
fprintf( Fichier, "\n\n");
fprintf( Fichier, "C_Start:\n");
}
/* ---------------------------------------------------------------------------------------------- */
void MkHead2( FILE *Fichier, TSource *Definition )
{
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n");
	fprintf( Fichier, ";\tTitle:%s", Definition->Title);
	fprintf( Fichier, ";\n");
	fprintf( Fichier, ";\tCopyright (c) %s %s\n", Definition->Author, Definition->Date);
	fprintf( Fichier, ";\tCode generated for DEVPAC 3\n");
	fprintf( Fichier, ";\n");
	fprintf( Fichier, ";\tRoutine business:%s\n", Definition->Business);
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n");
	fprintf( Fichier, "\n");
	fprintf( Fichier, "\t\tinclude\t\t\".\\Include\\sysapi.inc\"\n");
	fprintf( Fichier, "\t\tinclude\t\t\".\\Include\\jag.inc\"\n");
	fprintf( Fichier, "\n");
	fprintf( Fichier, "\t\tXDEF\tC_Start\n");
	fprintf( Fichier, "\t\tXDEF\tC_Len\n");
	fprintf( Fichier, "\n\n");

	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n");
	fprintf( Fichier, ";\tSZ_PARAM_FROM_HOST = Lenght of user data block await from the host\n");
	fprintf( Fichier, ";\tSZ_RESULT_TO_HOST = Lenght of user data block await from the host\n\n");

	fprintf( Fichier, "SZ_PARAM_FROM_HOST\tequ\t%d\n", Definition->SizeParamIn );
	fprintf( Fichier, "SZ_RESULT_TO_HOST\tequ\t%d\n", Definition->SizeParamOut);

	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n\n");
	fprintf( Fichier, "\t\tTEXT\n");
	fprintf( Fichier, "\n\n");
	fprintf( Fichier, "C_Start:\n");
}
/* ---------------------------------------------------------------------------------------------- */
void MakeMsgBegin( FILE *Fichier )
{
	fprintf( Fichier, "\t\tpea.l\t\tWelcome(pc)\n");
	fprintf( Fichier, "\t\tmove.w\t\t#DBMSG,-(sp)\n");
	fprintf( Fichier, "\t\ttrap\t\t#SYSTEM\n");
	fprintf( Fichier, "\t\taddq.l\t\t#6,sp\n");
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n\n");
}
/* ---------------------------------------------------------------------------------------------- */
void MkIcon( FILE *Fichier, TSource *Definition )
{
	fprintf( Fichier, "\t\tmove.w\t\t#%sEnd-%sBegin,-(sp)\n", Definition->IconName, Definition->IconName);
	fprintf( Fichier, "\t\tmove.l\t\t#%sBegin,-(sp)\n", Definition->IconName);
	fprintf( Fichier, "\t\tmove.w\t\t#SETICONPRG,-(sp)\n");
	fprintf( Fichier, "\t\ttrap\t\t#SYSTEM\n");
	fprintf( Fichier, "\t\taddq.l\t\t#8,sp\n");
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n\n");

}
/* ---------------------------------------------------------------------------------------------- */
void MkCurs( FILE *Fichier, TSource *Definition )
{
	fprintf( Fichier, "\t\tmove.w\t\t#%sEnd-%sBegin,-(sp)\t\t; Lenght of packed datas\n", Definition->CursorName, Definition->CursorName);
	fprintf( Fichier, "\t\tmove.l\t\t#%sBegin,-(sp)\t\t; Address of start packed datas\n", Definition->CursorName);
	fprintf( Fichier, "\t\tmove.w\t\t#USER_MOUSE,-(sp)\t\t; User define cursor\n");
	fprintf( Fichier, "\t\tmove.w\t\t#SETPOINTER,-(sp)\n");
	fprintf( Fichier, "\t\ttrap\t\t#SYSTEM\n");
	fprintf( Fichier, "\t\taddq.l\t\t#4,sp\n");
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n\n");
}
/* ---------------------------------------------------------------------------------------------- */
void MakeBody( FILE *Fichier, TSource *Definition )
{
	fprintf( Fichier, ";\tWait for a block which contains parameters you wants\n");
	fprintf( Fichier, "Await:\t\tmove.l\t\t#SZ_PARAM_FROM_HOST,-(sp)\n");
	fprintf( Fichier, "\t\tpea.l\t\tParamIn(pc)\n");
	fprintf( Fichier, "\t\tmove.l\t\t#TOOLBOX_PID,-(sp)\n");
	fprintf( Fichier, "\t\tmove.w\t\t#GETDATA,-(sp)\n");
	fprintf( Fichier, "\t\ttrap\t\t#SYSTEM\n");
	fprintf( Fichier, "\t\tadd.l\t\t#14,sp\n\n");

	fprintf( Fichier, "\t\ttst.l\t\td0\t\t;\tequal 0 => Host didn't accept to send any block\n\n");
	fprintf( Fichier, "\t\tbeq.s\t\tPterm\t\t;\tIn this case what can we do !\n\n");
			
	fprintf( Fichier, "\t\tmove.w\t\tParam(pc),d0\t\t;\tGet first parameter...\n");
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n");
	fprintf( Fichier, ";\t Code here the way to get your parameters and what to perform...\n\n");

	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n\n");
	fprintf( Fichier, ";\tSend to the host the results\n\n");

	fprintf( Fichier, "Results:\t\n\n");

	fprintf( Fichier, "\t\tmove.l\t\t#SZ_PARAM_FROM_HOST,-(sp)\n");
	fprintf( Fichier, "\t\tpea.l\t\tParamOut(pc)\n");
	fprintf( Fichier, "\t\tmove.l\t\t#TOOLBOX_PID,-(sp)\n");
	fprintf( Fichier, "\t\tmove.w\t\t#SENDDATA,-(sp)\n");
	fprintf( Fichier, "\t\ttrap\t\t#SYSTEM\n");
	fprintf( Fichier, "\t\tadd.l\t\t#14,sp\n");

	fprintf( Fichier, "\t\tbra\t\tAwait\n");
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n\n");

}
/* ---------------------------------------------------------------------------------------------- */
void MkBodyEmpty( FILE *Fichier )
{
	fprintf( Fichier, ";\t>>> Body program by user\n\n");
	fprintf( Fichier, "Main:\t\n\n");	
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n\n");
}
/* ---------------------------------------------------------------------------------------------- */
void MakeMsgEnd( FILE *Fichier )
{
	fprintf( Fichier, "\t\tpea.l\t\tGoodbye(pc)\n");
	fprintf( Fichier, "\t\tmove.w\t\t#DBMSG,-(sp)\n");
	fprintf( Fichier, "\t\ttrap\t\t#SYSTEM\n");
	fprintf( Fichier, "\t\taddq.l\t\t#6,sp\n");
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n\n");
}
/* ---------------------------------------------------------------------------------------------- */
void MakePterm( FILE *Fichier )
{
	fprintf( Fichier, "Pterm:\tmove.w\t\t#PTERM,-(sp)\n");
	fprintf( Fichier, "\t\ttrap\t\t#SYSTEM\n");
	fprintf( Fichier, "\t\tillegal\n\n");
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n");

}
/* ---------------------------------------------------------------------------------------------- */
void MakeData( FILE *Fichier, TSource *Definition )
{
    if( Definition->BeginMessage )
    {
		fprintf( Fichier, "\t\tDATA\n");
		fprintf( Fichier, "\t\tEVEN\n\n");
		fprintf( Fichier, "Welcome:dc.b\t\"%s\",0\n\n", Definition->TextMsgStart);
	}
		
    if( Definition->EndMessage )
    {
		fprintf( Fichier, "\t\tDATA\n");
		fprintf( Fichier, "\t\tEVEN\n\n");
		fprintf( Fichier, "Goodbye:dc.b\t\"%s\",0\n\n", Definition->TextMsgEnd);
	}
}
/* ---------------------------------------------------------------------------------------------- */
void MkFoot( FILE *Fichier )
{
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n");
	fprintf( Fichier, "C_End:\n");
	fprintf( Fichier, "\t\tEND\n");
}
/* ---------------------------------------------------------------------------------------------- */
void MkFoot2( FILE *Fichier, TSource *Definition )
{
	unsigned long	Indice, Limite;
	
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n");
    fprintf( Fichier, "\t\tDATA\n");
	fprintf( Fichier, "\t\tEVEN\n\n");

	fprintf( Fichier, ";\tInput buffer host to Jagauar\n");
	fprintf( Fichier, "ParamIn:\n");
	
	/*	Dterminer le nombre de mots (16 bits)	*/
	Limite	=	Definition->SizeParamIn;
	Limite	=	( Limite & 0xFFFFFFFEL ) / 2;
	
	for(Indice = 1; Indice <= Limite; Indice++)
	{
		fprintf( Fichier, "\t\tdc.w\t0\n");
	}
	/*	Si limite est infrieur  la valeur relle => Impair	*/
	if( Definition->SizeParamIn & 0x00000001)
		fprintf( Fichier, "\t\tdc.b\t0\n");
		
		
    fprintf( Fichier, "\n\t\tDATA\n");
	fprintf( Fichier, "\t\tEVEN\n\n");
	fprintf( Fichier, ";\tOutput buffer Jagauar to host\n");
	fprintf( Fichier, "ParamOut:\n");
	
	/*	Dterminer le nombre de mots (16 bits)	*/
	Limite	=	Definition->SizeParamOut;
	Limite	=	( Limite & 0xFFFFFFFEL ) / 2;
	
	for(Indice = 1; Indice <= Limite; Indice++)
	{
		fprintf( Fichier, "\t\tdc.w\t0\n");
	}
	/*	Si limite est infrieur  la valeur relle => Impair	*/
	if( Definition->SizeParamOut & 0x00000001 )
		fprintf( Fichier, "\t\tdc.b\t0\n");
	
	fprintf( Fichier, "\n;\t------------------------------------------------------------------------------\n");
	fprintf( Fichier, "C_End\tdc.l\t1\n\n");
	fprintf( Fichier, "C_Len:\tdc.l\tC_End - C_Start\n");

	fprintf( Fichier, "\t\tEND\n");
}
/* ---------------------------------------------------------------------------------------------- */
void MkIconData( FILE *Fichier, TSource *Definition )
{
	char	L_Destination[PATH_LEN+FILENAME_LEN]= "\0";
	char	*Pointer;
	int		Status;
		
	strcpy(L_Destination, Definition->IconPathName);
	Pointer	=	strrchr(L_Destination, '.');
	if( Pointer != NULL)
	{
		*Pointer	=	0;
	}
	strcat(L_Destination, ".Cci");
								
	Status	=	PackCCI( Definition->IconPathName, L_Destination);
	DispErr( Status );
/*	switch( Status )
	{
		case	JTB_ENOCRYFILE:	sprintf(Texte, "[3][ %s | %s.cry ][Ok]", GetMessage(ERROR_CRY), Definition->IconName);
								form_alert(1, Texte);
								break;
								
		case	JTB_ENOCCIFILE:	sprintf(Texte, "[3][ %s | %s.cci ][Ok]", GetMessage(ERROR_CCI), Definition->IconName);
								form_alert(1, Texte);
								break;
	}*/

	fprintf( Fichier, "\t\tDATA\n");
	fprintf( Fichier, "\t\tEVEN\n");
	fprintf( Fichier, "\t\t; Icon program' datas\n");
	fprintf( Fichier, "\t\tinclude\t\t\".\\Datas\\%s.cci\"\n\n", Definition->IconName);
}
/* ---------------------------------------------------------------------------------------------- */
void MkCursData( FILE *Fichier, TSource *Definition )
{
	char	L_Destination[PATH_LEN+FILENAME_LEN]= "\0";
	char	*Pointer;
	int		Status;
	
	strcpy(L_Destination, Definition->CursorPathName);
	Pointer	=	strrchr(L_Destination, '.');
	if( Pointer != NULL)
	{
		*Pointer	=	0;
	}
	strcat(L_Destination, ".Cci");
								
	Status	=	PackCCI(Definition->CursorPathName, L_Destination);
	DispErr( Status );
	
/*	switch( Status )
	{
		case	NO_CRY_FILE:	sprintf(Texte, "[3][ %s | %s.cry ][Ok]", GetMessage(ERROR_CRY), Definition->CursorName);
								form_alert(1, Texte);
								break;
								
		case	NO_CCI_FILE:	sprintf(Texte, "[3][ %s | %s.cci ][Ok]", GetMessage(ERROR_CCI), Definition->CursorName);
								form_alert(1, Texte);
								break;
	}*/
	
	fprintf( Fichier, "\t\tDATA\n");
	fprintf( Fichier, "\t\tEVEN\n");
	fprintf( Fichier, "\t\t; Cursor program' datas\n");
	fprintf( Fichier, "\t\tinclude\t\t\".\\Datas\\%s.cci\"\n\n", Definition->CursorName);
}
/* ---------------------------------------------------------------------------------------------- */
void MakeCooperant( FILE *Fichier, TSource *Definition )
/*
	Generation d'un source d'un programme cooprant utilis par une application GEM.
*/
{
	MkHead2( Fichier, Definition );

	if( Definition->BeginMessage )
		MakeMsgBegin( Fichier );

	if( Definition->Icon )
		MkIcon( Fichier, Definition );
		
	if( Definition->Cursor )
		MkCurs( Fichier, Definition );

    MakeBody( Fichier, Definition );

	if( Definition->EndMessage )
		MakeMsgEnd( Fichier );

	MakePterm( Fichier );

	if( Definition->Icon )
		MkIconData( Fichier, Definition );
		
	if( Definition->Cursor )
		MkCursData( Fichier, Definition );

	MakeData( Fichier, Definition );
	MkFoot2( Fichier, Definition );
}
/* ---------------------------------------------------------------------------------------------- */
void MakeComplete( FILE *Fichier, TSource *Definition )
/*
	Generation d'un source d'un programme libre sous JagOS.
*/
{
	MkHead( Fichier, Definition );

	if( Definition->BeginMessage )
		MakeMsgBegin( Fichier );

	if( Definition->Icon )
		MkIcon( Fichier, Definition );

	if( Definition->Cursor )
		MkCurs( Fichier, Definition );

	/*	No body to generate */
	MkBodyEmpty( Fichier );
	
	if( Definition->EndMessage )
		MakeMsgEnd( Fichier );

	MakePterm( Fichier );

	if( Definition->Icon )
		MkIconData( Fichier, Definition );
		
	if( Definition->Cursor )
		MkCursData( Fichier, Definition );

	MakeData( Fichier, Definition );
	MkFoot( Fichier );
}
void MakeSource( FILE *Fichier, TSource *Definition )
/*
	Generation d'un source assembleur.
*/
{
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n");
	fprintf( Fichier, ";\tTitle:%s\n", Definition->Title);
	fprintf( Fichier, ";\n");
	fprintf( Fichier, ";\tCopyright (c) %s %s\n", Definition->Author, Definition->Date);
	fprintf( Fichier, ";\tCode generated by JagStudio98 for DEVPAC 3, copyright FAVARD laurent 1996-1998\n");
	fprintf( Fichier, ";\n");
	fprintf( Fichier, ";\tBusiness:%s\n", Definition->Business);
	fprintf( Fichier, ";\t------------------------------------------------------------------------------\n");
	fprintf( Fichier, "\n");	
}
/* ---------------------------------------------------------------------------------------------- */
int Generation( TProjet *pProjet, TSource *Definition )
{
	FILE			*Fichier;
	TProjet			Projet;

	Projet	=	*pProjet;	
	if(!A_FileSelector(Projet.SrcPathName, Projet.SrcFileName, Projet.SrcExtension, Projet.SrcPath, G_SAVE_GEN)) 
		return	FALSE;
		
	*pProjet	=	Projet;
	
	MS_Mouse(MS_SLEEP, NULL);				
	if( strrchr( pProjet->SrcPathName, '.' ) == NULL )
		strcat( pProjet->SrcPathName, EXT_SRC2 );

	/*	Alimenter les infos sur l'executable */
	strcpy( pProjet->ExePath, pProjet->SrcPath );
	
	strcpy( pProjet->ExeFileName, Definition->ExecName );
	strcat( pProjet->ExeFileName, EXT_JAG2 );

	strcpy( pProjet->ExePathName, pProjet->SrcPath );
	strcat( pProjet->ExePathName, "\\" );
	strcat( pProjet->ExePathName, pProjet->ExeFileName );
	
    Fichier	=	fopen( pProjet->SrcPathName, "w" );
    if( Fichier == NULL )
    	return	FALSE;
    	
	switch( Definition->Type )
    {
		case	COOPERANT:  MakeCooperant( Fichier, Definition );
        					break;

		case	SOURCEASM:	MakeSource( Fichier, Definition );
        					break;

		case	FREEWITHOS: MakeComplete( Fichier, Definition );
        					break;

		case	FREEPROGRAM:MkHead( Fichier, Definition );
        					MkFoot( Fichier );
        					break;

        default:            form_alert(1, "[0][ type generation unknow ][Ok]");
        					break;
	}
	MS_Mouse(ARROW, NULL);
	fclose( Fichier );
	return	TRUE;
}

